import os
from music21 import *
import numpy as np
import collections

def check_srting_files(test_string, list_info_lyrics):
    list_mathces = []
    mathces_ranges = []
    for i, list_elem in enumerate(list_info_lyrics):
        current_phrase = ''
        j=0
        while len(current_phrase)<len(test_string):
            #print(j,len(current_phrase),len(test_string))
            list_sylable=list_info_lyrics[(i+j)%len(list_info_lyrics)][6]
            current_phrase+=list_sylable
            test_string_form = test_string.replace(' ','').replace(',','').replace(';','').replace('.','').lower()
            current_phrase_form = current_phrase.replace(',','').replace(';','').replace('.','').lower()
            #print(test_string_form, '---',current_phrase_form)
            #print(test_string_form == current_phrase_form)
            if test_string_form == current_phrase_form:
                start_meas = list_info_lyrics[i][4]
                end_meas = list_info_lyrics[i+j][4]
                list_mathces.append((list_elem[0],list_elem[1],list_elem[2],list_elem[3],start_meas,end_meas))
            j+=1;

    return list_mathces


def check_srting_array_files(test_list, list_info_lyrics):
    list_mathces = []
    mathces_ranges = []
    for i, l in enumerate(list_info_lyrics):
        equals = True
        #print('List step ',i)
        for j, t in enumerate(test_list):
            list_sylable=list_info_lyrics[(i+j)%len(list_info_lyrics)][6]
            test_sylable=test_list[j]
            #print('\tComparing ', list_sylable,test_sylable)
            #print('\t', list_sylable == test_sylable)
            if list_sylable.replace(',','').replace(';','').replace('.','').lower() != test_sylable.lower():
                #print('\tNOP')
                equals = False
        if equals:
            #print('\t\tFOUND ONE')
            start_meas = list_info_lyrics[i][4]
            end_meas = list_info_lyrics[i+len(test_list)-1][4]
            list_mathces.append((l[0],l[1],l[2],l[3],start_meas,end_meas))
            #mathces_ranges.append((list_info_lyrics[i][4],list_info_lyrics[i+len(test_list)-1][4]))
    return list_mathces


def folder_tupple(rootdir):
    #rootdir='misa_completa/'
    scores = []
    parts_lists = []
    parts_names_lists = []
    tupples = []
    file_num = 0
    for subdir, dirs, files in os.walk(rootdir):
        #print(subdir)
        for file in files:
            #print('\t',file)
            if file.split('.')[1]=='xml':
                pthName = os.path.join(subdir, file)
                #print('\t',file)
                s = converter.parse(pthName)
                names,parts =extract_parts(s)
                parts_lists.append(parts)
                parts_names_lists.append(names)
                lyr =get_lyrics_tupples(s,file_num,file,names)
                #print(lyr)
                tupples.append(lyr)
                remove_breaks(s)
                scores.append(s)
                file_num+=1
    flt = []
    for t in tupples:
        for s in t:
            #print(s)
            flt.append(s)
    return flt, scores, parts


def remove_breaks(strm):
    for m in strm.getElementsByClass(stream.Measure):
        for l in m.getElementsByClass(layout.SystemLayout):
            l.isNew=False
            #print(l.isNew)
        for l in m.getElementsByClass(layout.PageLayout):
            l.isNew=False
            #print(l.isNew)
    for p in strm.getElementsByClass(stream.PartStaff):
        for m in p.getElementsByClass(stream.Measure):
            for l in m.getElementsByClass(layout.SystemLayout):
                l.isNew=False
                #print(l.isNew)
            for l in m.getElementsByClass(layout.PageLayout):
                l.isNew=False
                #print(l.isNew)
    return strm


def extract_parts(s):
    # Extract parts
    parts = s.getElementsByClass('Part')
    # Create array with part names
    part_names = []
    for i,p in enumerate(parts):
        #print(i,p)
        part_names.append(p.partName)
    return part_names,parts


def get_lyrics_tupples(s,num_score,name,part_names):
    lyrics_text = ''
    lyrics_info_tupple = []
    for e in s.recurse():
        if type(e) is stream.Part:
            curren_part = e.partName
            lyrics_text+= '\n'+curren_part+ ':\t'
        if type(e) is note.Note:
            if len(e.lyrics) > 0:
                lir_Text = e.lyrics[0].text
                lyrics_info_tupple.append((num_score,name,part_names.index(curren_part),curren_part,e.measureNumber,e.offset,lir_Text))
                lyrics_text += lir_Text
                #print(lyrics_text)
    return lyrics_info_tupple

def get_pitch_list(stream_test):
    pitches_in_stream =[]
    midi_in_stream =[]
    dur_vals = []
    dur_types = []
    for r in stream_test.recurse():
        if  type(r) is chord.Chord:
            for c in r.pitches:
                pitches_in_stream.append(c.name)
            dur_types.append(r.duration.type)
            dur_vals.append(float(r.duration.quarterLength))
        if  type(r) is note.Note:
            pitches_in_stream.append(r.name)
            midi_in_stream.append(r.pitch.midi)
            dur_types.append(r.duration.type)
            dur_vals.append(float(r.duration.quarterLength))
        if  type(r) is note.Rest:
            pitches_in_stream.append(r.name)
            dur_types.append(r.duration.type)
            midi_in_stream.append(0)
            dur_vals.append(float(r.duration.quarterLength))
    return pitches_in_stream, midi_in_stream, dur_types, dur_vals
    

def get_stream_from_match(scores,parts,match_element):
    sc_nm = match_element[0]
    pt_nm= match_element[2]
    ms_i =match_element[4]
    ms_f =match_element[5]
    curr_stream = scores[sc_nm].parts[pt_nm].measures(ms_i,ms_f)
    return remove_breaks(curr_stream)


def get_list_matches(scores,parts,lyric_matches):
    pitches_matches = []
    midi_matches = []
    d_types_matches = []
    d_vals_matches = []
    
    for i, p in enumerate(lyric_matches ):
        #parts[a[0]].measures(a[2],a[2]+2).show()
        #print('\n\n',p)
        #try:
        stream_test = get_stream_from_match(scores,parts,p)
        pitches, midis, d_types, d_vals = get_pitch_list(stream_test )
        pitches_matches.append(pitches)
        midi_matches.append(tuple(midis))
        d_types_matches.append(d_types)
        d_vals_matches.append(tuple(d_vals))

    midi_matches=list(set(midi_matches))
    midi_matches.sort(key=len,reverse=False)

    d_vals_matches=list(set(d_vals_matches))
    d_vals_matches.sort(key=len,reverse=False)

    return pitches_matches, midi_matches, d_types_matches,d_vals_matches

def show_matches_scores_files(scores,lyric_matches):
    for i, p in enumerate(lyric_matches ):
        #parts[a[0]].measures(a[2],a[2]+2).show()
        print('\n\n',p)
        #try:
        stream_test = get_stream_from_match(scores,p)
        stream_test.show()
            #remove_breaks(scores[p[0]].parts[p[2]].measures(p[4],p[5])).show()
        #except:
        #    print('dim error') 


def write_matches_scores_files(folder,scores,parts,lyric_matches, num_meas=1):
    for i, p in enumerate(lyric_matches ):
        #parts[a[0]].measures(a[2],a[2]+2).show()
        print(p)
        stream_test = get_stream_from_match(scores,parts,p)
        stream_test.write('musicxml',folder+'/'+str(i)+'.xml')


#=================================================================

# WORKING
def calc_part_active_measures(parts):
    orch_silence = []
    for i,p in enumerate(parts):
        #print(i,p)
        ms_silence = []
        for m in parts[i].getElementsByClass('Measure'):
            #print(m)
            is_playing = False
            for n in m.recurse():
                if type(n)==note.Note:
                    is_playing=True
            ms_silence.append(int(is_playing))
        orch_silence.append(ms_silence)
    return orch_silence

# WORKING
def calc_orch_density(parts_active_vector,selection=[]):
    if len(selection)==0:
        selection = [i for i in range(len(parts_active_vector))]
    number_parts_active = []
    for i in range(len(parts_active_vector[0])):
        #print(i)
        sm = 0
        #for idx in selection:
        #    sm+=o[idx]
        parts_vector_selection = [parts_active_vector[sel] for i, sel in enumerate(selection)]
        for part_vector in parts_vector_selection:
            #print(part_vector[i])
            sm+=part_vector[i]
        number_parts_active.append(sm)
    return number_parts_active