// server.js
// load the things we need
var express = require('express');
var app = express();
var bodyParser = require("body-parser");
var PythonShell = require('python-shell');
var listTupples = "empty";

// set the view engine to ejs
app.set('view engine', 'ejs');
app.use(express.static(__dirname + '/public'));

// use res.render to load up an ejs view file

// index page 
app.get('/', function (req, res) {

    res.render('pages/index', {
        drinks: listTupples,
    });
});
// about page 
app.get('/about', function (req, res) {
    res.render('pages/about');
});

// Python run code
app.get('/search_results', function (req, res) {
    //var name = req.body.firstName + ' ' + req.body.lastName;
    //res.send(score);
    var randId = Math.floor(Math.random() * 1000000000);
    console.log("The ID for this query is: " + randId);
    console.log(req.query.query);
    //var name = req.body.firstName + ' ' + req.body.lastName;
    //res.send(score);
    var p = new Promise(function (resolve, reject) {
        var requestString = req.query.query;
        var options = {
            //mode: 'text',
            //pythonPath: 'path/to/python',
            //pythonOptions: ['-u'],
            //scriptPath: 'path/to/my/scripts',
            //pythonPath: 'python3', // THIS LINE IN UBUNTU
            args: ['public/misa_completa', 'public/' + randId, requestString]
        };
        console.log("Enter promise");
        // Do an async task async task and then...
        PythonShell.run('python_code/main.py', options, function (err, results) {
            console.log("Runing shell");
            if (err) {
                console.log(err);
            }
            // results is an array consisting of messages collected during execution
            //console.log('results: %j', results);
            score = results;
            console.log(results);
            listTupples = results;
            resolve('Success!');
        });
    });

    p.then(function () {
        console.log("Finished");
        //console.log(score);
        //res.sendFile(__dirname + '/html_views/score_verovio.html')
        res.render('pages/search_results', {
            listValues: listTupples,
            idValue: randId
        });
    }).catch(function (err) {
        /* error :( */
        console.log("There was an error " + err);
    })
});


// Server
app.listen(5000);
console.log('5000 is the magic port');  