// Documentation
// https://github.com/JedWatson/react-select

import React from 'react';
// import Select from 'react-select';
import Multiselect from 'react-select';
import makeAnimated from 'react-select/lib/animated';

// const options = [
//   { value: 'chocolate', label: 'Chocolate' },
//   { value: 'strawberry', label: 'Strawberry' },
//   { value: 'vanilla', label: 'Vanilla' }
// ];
class FileSelect extends React.Component {

  constructor(props) {
    super(props);
    this.state = { selectedOption: null }
  }


  componentDidMount() {
    // Call our fetch function below once the component mounts
    this.callBackendAPI()
      .then(res => this.setState({ data: res.file_list }))
      .catch(err => console.log(err));
  }

  // Fetches our GET route from the Express server. 
  // (Note the route we are fetching matches the GET route from server.js
  callBackendAPI = async () => {
    let route = '/files/getfileslist';
    const response = await fetch(route);
    const body = await response.json();
    console.log(body);
    if (response.status !== 200) throw Error(body.message)
    return body;
  };

  handleChange = (selectedOption) => {
    this.setState({ selectedOption });
    console.log(`Option selected:`, selectedOption);
    this.props.callbackFromParent(selectedOption);
  }
  
  render() {
    const { selectedOption } = this.state;

    return (
      <Multiselect
        value={selectedOption}
        onChange={this.handleChange}
        components={makeAnimated()}
        // isMulti
        options={this.state.data}
      />
    );
  }
}

export default FileSelect
