import React, { Component } from 'react';
// import Files from '../Files/Files'
// import FileSelect from '../Files/FileSelect'
// import SimpleTable from '../SimpleTable/SimpeTable'
import MUIDataTable from "mui-datatables";



const options = {
    filterType: 'textField',
    // onCellClick: data=>console.log("Cell click: ",data),
    onRowsSelect: (data, allSelected) => console.log("Row select: ", data, allSelected),
    ononRowClick: (data, allSelected) => console.log("Row click: ", data, allSelected)
};
class PageFileManager extends Component {

    constructor(props) {
        super(props);
        this.state = {
            file_selected: "",
            columns: ["value", "label"],
            data: []
        }

        this.myCallback = this.myCallback.bind(this);
    }

    componentDidMount() {
        // TODO: index.js:1446 Warning: Each child in a list should have a unique "key" prop.
        this.callBackendAPI()
            .then(res => this.setState({
                columns: res.columns_names,
                data: res.rows
            }))
            .catch(err => console.log(err));
    }

    // Fetches our GET route from the Express server. 
    // (Note the route we are fetching matches the GET route from server.js
    callBackendAPI = async () => {
        console.log("Enter callback api getcsvlist ", this.state)
        // let route = '/files/getfileslist';
        let route = '/files/getcsvlist';
        const response = await fetch(route);
        const body = await response.json();
        console.log("CSV body ",body);
        if (response.status !== 200) throw Error(body.message)
        return body;
    };

    myCallback = (data) => {
        if (data !== undefined) {
            console.log("Callback\n", data.label);
            let selected = data.label ? data.label : "no file selected."
            this.setState({ file_selected: selected });
        }
    }

    render() {
        return (
            <div>
                <h3>File manager Page</h3>
                <ul>
                    <li>Uploads</li>
                    <li>Delete</li>
                    <li>Create groupings</li>
                    <li>Paradigms</li>
                </ul>
                {/* <Files /> */}
                {/* <SimpleTable /> */}
                {/* TODO: Handle css with too many columns */}
                <MUIDataTable
                    title={"Archivos"}
                    data={this.state.data}
                    columns={this.state.columns}
                    options={options}
                />
                {/* <EnhancedTable data={this.state.data} /> */}
                {/* <FileSelect callbackFromParent={this.myCallback} /> */}
                <p>FILE: {this.state.file_selected}</p>
                <p>{"" + this.state.data}</p>
            </div>
        );
    }
}

export default PageFileManager;


