import React, { Component } from 'react';

// TODO: Create musicxml and several graphs for each score
// so they can be displayed
class SingleFileOperation extends Component {
  constructor(props) {
    super(props);
    let titleName = "";
    switch (props.type) {
      case "chordify":
        titleName = "Chordify module"
        break;
      case "dtw":
        titleName = "DTW module"
        break;
      case "score":
        titleName = "Original score module"
        break;
      case "stats":
        titleName = "Stats score module"
        break;
      default:
        titleName = ""
    }

    this.state = {
      data: null,
      operation: props.type,
      file: props.filename,
      name: titleName
    }
    this.startCalculation = this.startCalculation.bind(this);
  }

  startCalculation = () => {
    let currFile = this.props.getCurrentFile();
    this.setState({ file:  currFile}, () => {
      // Call our fetch function below once the component mounts
      console.log("CHANGED FILE ",this.state.file )
      this.callBackendAPI()
        .then(res => this.setState({ data: res.svg }))
        .catch(err => console.log(err));
    })
  }

  // Fetches our GET route from the Express server. 
  // (Note the route we are fetching matches the GET route from server.js
  callBackendAPI = async () => {
    console.log("Enter callback api ",this.state)
    let route = '/queries/singleoperations/';
    let operation = this.state.operation;
    let file = this.state.file;
    console.log("Operation: ", operation, " File: ", file);
    const response = await fetch(route + '?type=' + operation + '&file=' + file);
    const body = await response.json();
    console.log(body);
    if (response.status !== 200) throw Error(body.message)

    return body;
  };

  render() {
    return (
      <div>
        <h1>{this.state.name}</h1>
        <button onClick={this.startCalculation}>START CALCULATION</button>
        <div dangerouslySetInnerHTML={{ __html: this.state.data }} />
      </div>
    );
  }
}

export default SingleFileOperation;