// //https://medium.freecodecamp.org/how-to-create-file-upload-with-react-and-node-2aa3f9aab3f0
// The pitfalls and improvements
// Uploading using React and Node has no pitfalls, but this demo does! As it was just a demo, errors weren’t handled well. There’s no way to cancel the upload; if you refresh the front-end while uploading, the server will crash.
// The server doesn’t check for script files, not does it sanitize them.
// So this is how to handle uploads on React with a Node as a backend. You can also use React to do the same with API to remote server and data storage solutions.

let express = require('express');
let rp = require('../modules/runpython.js'); // require relative to local position
let vr = require('../modules/scores.js'); // require relative to local position
var fs = require('fs');
var path = require('path');
const csv = require('csv-parser');

let router = express.Router();

router.get('/testing', (req, res) => {
  console.log('===========\nTEST');
  // console.log(req);
  res.send({ express: 'cosa.' });
});

router.get('/getcsvlist', (req, res) => {
  let columnsNames = [];
  let values = [];

  // var obj = { 0: 'a', 1: 'b', 2: 'c' };
  // console.log(Object.entries(obj)); // [ ['0', 'a'], ['1', 'b'], ['2', 'c'] ]
  fs.createReadStream('analysis/table.csv')
    .pipe(csv())
    .on('data', function(data) {
      try {
        //perform the operation
        columnsNames = Object.entries(data).map(elem => elem[0]);
        values.push(Object.entries(data).map(elem => elem[1]));
      } catch (err) {
        //error handler
      }
    })
    .on('end', function() {
      //some final operation
      res.send({
        columns_names: columnsNames,
        rows: values
      });
    });
});

router.get('/getfileslist', (req, res) => {
  var dirPath = 'files'; //directory path
  var fileType = '.musicxml'; //file extension
  var files = [];
  let counter = 0;
  fs.readdir(dirPath, function(err, list) {
    if (err) throw err;
    sendListFiles = { file_list: [] };
    for (var i = 0; i < list.length; i++) {
      if (path.extname(list[i]) === fileType) {
        console.log(list[i]); //print the file
        files.push(list[i]); //store the file name into the array files
        sendListFiles.file_list.push({
          id: counter,
          value: list[i],
          label: list[i]
        });
        counter++;
      }
    }
    // res.send({ files_list: files });
    res.send(sendListFiles);
  });
});

router.post('/upload', (req, res, next) => {
  console.log('===========\nStart Upload');
  console.log(req);
  let uploadFile = req.files.file;
  const fileName = req.files.file.name;
  uploadFile.mv(`${__dirname}/public/files/${fileName}`, function(err) {
    if (err) {
      return res.status(500).send(err);
    }
    res.json({
      file: `public/${req.files.file.name}`
    });
  });
});

module.exports = router;
