// https://medium.com/@maison.moa/setting-up-an-express-backend-server-for-create-react-app-bc7620b20a61

/*
nodemon server.js
cd client npm start
*/

const express = require('express');
const bodyParser = require('body-parser');
var cors = require('cors');

// Then use it before your routes are set up:
const app = express();
const port = process.env.PORT || 5000;

app.use(cors());

// REST tips Query strings
// https://coursework.vschool.io/express-params-and-query/
// https://stackoverflow.com/questions/15128849/using-multiple-parameters-in-url-in-express
var queriesRouter = require('./routes/queries');
var filesRouter = require('./routes/files');

app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: true }));

app.use('/queries', queriesRouter);
app.use('/files', filesRouter);

// TODO: implement graphs
// https://github.com/crubier/react-graph-vis
app.listen(port, () => console.log(`Listening on port ${port}`));
