from music21 import *
import simplemir.structure as st
import simplemir.music21utils as mu
import simplemir.feature_extraction as fx
import json


def run_dtw_api(in_path):
    # Configured when called from node and files in main folder
    music = converter.parse(in_path)
    music = mu.remove_breaks(music)
    svg_out = st.graph_dtw_multiple_sizes(music, 2, 3)
    return svg_out


def run_chordify_api(in_path):
    # Configured when called from node and files in main folder
    music = converter.parse(in_path)
    music = music.chordify()
    music = mu.remove_breaks(music)
    xml_test = mu.stream_xml_string(music)
    return xml_test


def run_score_api(in_path):
    music = converter.parse(in_path)
    music = mu.remove_breaks(music)
    xml_test = mu.stream_xml_string(music)
    return xml_test


def run_stats_api(in_path):
    music = converter.parse(in_path)
    feats = fx.Feature_extraction(in_path, music)
    return json.dumps(feats.master_dict)
