#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Jan 25 15:44:50 2017

@author: holomorfo
"""

import simplemir.midiutils as mf
import simplemir.fuzzyutils as ch
from mido import MidiFile
import time

#===============================================

print("=======================================")
start = time.time()
print("Start time")
#===============================================

# Calculations

#inputFile='ChopinEtude10'
inputFile='chpn-p20.mid'
#inputFile ='chpn-p20'
inputPath='../../music_files/midi_test/'
fileInputPath=inputPath+inputFile
print('Loaded midi file\n\t'+fileInputPath)
mid = MidiFile(fileInputPath)


# TODO: MidiFuzzy migrate to music21
# TODO: MidiFuzzy organize in sub functions

msgList=mf.getSortedMessages(mid)
print('Sorted Message list length ',len(msgList))
#mf.printList(msgList)

# Create duration table (pair ON/OFF messages)
dursList= mf.calculateDurations(msgList)
print('Sorted Duration list length ',len(dursList))
#mf.printList(dursList)

#===============================================

# Create list of segments from duration list
#   List of subsegments
#   Normal form
#   Tonality
print('===============\nRun trough All Segments Chords')
a= ch.ChordLabels()
a.runTroughAllSegmentsChords(dursList[:100])
a.calculateSegmentsReduced()
print('===============\nEnd Run trough All Segments Chords')


#===============================================
# Output
#print('Start output csv')
date =  time.strftime("%Y%m%d-%H%M%S")
fileSongCSV = 'output/'+date+'-'+inputFile+'_midi.csv'
fileSongCSVdurs = 'output/'+date+'-'+inputFile+'_durs.csv'

print('Saved Midi file list CSV\n\t'+fileSongCSV)
print('Saved Midi file durations list CSV\n\t '+fileSongCSVdurs)

mf.saveCsv(fileSongCSV,msgList)
mf.saveDursCsv(fileSongCSVdurs,dursList)

#============================================0
# Save reduced chords
fileSongChordsReducedCSV = 'output/'+date+'-'+inputFile+'_reducedchord.csv'
a.saveCsvReducedChords(fileSongChordsReducedCSV)

print('Saved Midi file list CSV\n\t'+fileSongCSV)
print('Saved Midi file durations list CSV\n\t '+fileSongCSVdurs)

mf.saveCsv(fileSongCSV,msgList)
mf.saveDursCsv(fileSongCSVdurs,dursList)


# Finnish calculations
end = time.time()
total = end-start
print("Total time: ",total)
print("=======================================")
mf.printList(a.segmentsList)
mf.printList(a.segmentListReduced)